package com.contec.jar.cms50ew;

import java.util.ArrayList;

import android.provider.CallLog;
import android.util.Log;

public class DevicePackManager {

	public static final int[] PackLength = { 0, 9, 9, 9, 9, 9, 4, 8, 8, 6, 4,
			4, 2, 3, 3, 8, // 0
			3, 9, 8, 9, 9, 9, 5, 7, 4, 0, 0, 0, 0, 0, 0, 10, // 1
			0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, // 2
			0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, // 3
			0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, // 4
			0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, // 5
			0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, // 6
			0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 9, 9, 9, 0, 0 // 7
	};

	public static final int e_pack_username = 0x05;// user info
	public static final int e_pack_savedate = 0x07;// data storage Date
	public static final int e_pack_savetime = 0x12;// data storage Time;
	public static final int e_pack_datalen = 0x08;// data length
	public static final int e_pack_savedatapi = 0x09;// save data have pi
	public static final int e_pack_savedata = 0x0F;// save data no pi
	public static final int e_pack_pitype = 0x0E;// hava pi or no. 0x00:hava pi;
													// 0x01:no pi
	public static final int e_pack_datacount = 0x0A;// user's data count
	public static final int e_pack_usernum = 0x10;// user number
	public static final int e_pack_realTimeData = 0x01;// Real Time Data
	public static final int e_pack_feedback = 0x0B;
	public static final int e_pack_check_sum = 0x18;
	public static final int e_pack_device_date = 0x16;

	public int mDataCount = 0;

	static int SPO2UpLimit = 100;
	static int SPO2LowLimit = 0;
	static int PULSEUpLimit = 254;
	static int PULSELowLimit = 0;
	static int PIUpLimit = 2200;
	static int PILowLimit = 0;

	public int CHECK_SUM = 0;

	// 连续数据的长度
	int mSegmentLen;
	// 连续数据接收到的包个数
	int mPackCount;
	byte pluse;
	byte spo2;
	// 血氧数据
	public DeviceDataSPO2H mSpo2h;

	public static final int e_spO2_exclude = 0x7f;
	public static final int e_pulse_exclude = 0xff;
	public static final int e_PI_exclude = 0xffff;

	boolean bGetPackId = false;
	byte[] curPack = new byte[9];
	int k = 0;
	int len = 0;
	int i;
	byte value;
	boolean flag = false;

	// public byte arrangeMessage(byte[] buf, int length) {
	// byte _return = 0;
	// for(i = 0; i < length; ++i){
	// value = buf[i];
	// if(bGetPackId){
	// if(value < 0){
	// curPack[k++] = value;
	// if(k >= len){
	// bGetPackId = false;
	// // PrintBytes.printData(curPack);
	// _return = processData(curPack);
	// }
	// }else{
	// bGetPackId = false;
	// continue;
	// }
	// }else{
	// bGetPackId = true;
	// k = 0;
	// len = PackLen(value);
	// if(value >= 0
	// && PackLength[value] > 0){
	// // bGetPackId = true;
	// // k = 0;
	// // len =PackLength[value];
	// curPack = new byte[len];
	// curPack[k++] = value;
	// }
	// }
	// }
	// return _return;
	// }
	
	public DevicePackManager() {
		mSpo2h = new DeviceDataSPO2H();
	}
	
	
	public byte arrangeMessage(byte[] buf, int length) {
//		Log.e("=====================", "========================");
//		// PrintBytes.printData(buf, length);
//		Log.e("=====================", "" + length);
//		Log.e("=====================", "========================");
		byte _return = 0;
		for (i = 0; i < length; ++i) {
			value = buf[i];
			if (bGetPackId) {
				curPack[k++] = value;
				// Log.e(">>>>>>>>>>>>>>>>>>>>>>>", "Value："+value);
				// Log.e(">>>>>>>>>>>>>>>>>>>>>>>", "接收长度："+k);
				if (k >= len) {
					bGetPackId = false;
					_return = processData(curPack);
					Log.e("hxk", "arrangeMessage()--->" + _return);
				}
			} else {
				bGetPackId = true;
				k = 0;
				len = PackLen(value);
				// Log.e(">>>>>>>>>>>>>>>>>>>>>>>", "Value："+value);
				// Log.e(">>>>>>>>>>>>>>>>>>>>>>>", "数据包长度："+len);
				Log.e("当前len返回的数据", "====" + len);
				if (len == 0) {
					_return = 0;
					bGetPackId = false;
				} else {
					curPack = new byte[len];
					curPack[k++] = value;
					// Log.e(">>>>>>>>>>>>>>>>>>>>>>>", "接收长度："+k);
					if (len == 1) {
						_return = processData(curPack);
						Log.e("hxk", "arrangeMessage()--->" + _return);
						bGetPackId = false;
					}
				}

			}
		}

		return _return;
	}

	public int PackLen(byte pHead) {
		int _return = 0;
		switch (pHead) {
		case (byte) 0xCF:
			_return = 10;
			flag = true;
			break;
		case (byte) 0xF2:
			_return = 8;
			flag = true;
			break;
		case (byte) 0xF3:
			_return = 3;
			flag = true;
			break;
		case (byte) 0xD0:
			_return = 14;
			flag = true;
			break;
		case (byte) 0xD1:
			_return = 4;
			flag = true;
			break;
		case (byte) 0xD2:
			_return = 20;
			flag = true;
			break;
		case (byte) 0xD3:
			_return = 20;
			flag = true;
			break;
		case (byte) 0x20:
			_return = 10;
		    break;
		default:
			_return = PackLength[value];
			flag = false;
			break;
		}
		return _return;
	}

	public void sum_Check(byte[] pack) {
		int _size = pack.length;
		Log.e("AAAAAAAAAAAAAAAAAA", "");
		Log.e("AAAAAAAAAAAAAAAAAA", ""+_size);
		Log.e("AAAAAAAAAAAAAAAAAA", "");
		for (int i = 0; i < _size; i++) {
			CHECK_SUM += (pack[i] & 0xff);
		}
	}

	/**
	 * unpack the package from device
	 * 
	 * <p>
	 * some device send to you command is shifting<br>
	 * pass thie method to return command int the deal
	 * 
	 * @param pack
	 *            the package of the device send to you
	 * @param len
	 *            the package of the device send to you length
	 * @return the original command in the deal
	 */
	public static byte[] unPack(byte[] pack) {
		int len = PackLength[pack[0]];
		for (int i = 2; i < len; ++i) {
			pack[i] &= (pack[1] << (9 - i)) | 0x7f;
		}
		pack[1] = (byte) 0x80;
		return pack;
	}

	/**
	 * pack command before send
	 * 
	 * <p>
	 * some device deal rule before send command need to shifting <br>
	 * so this method will pack your command
	 * 
	 * @param pack
	 *            you want to send command
	 * @param len
	 *            you want to send command length
	 * @return you need to send command
	 */
	public static byte[] doPack(byte[] pack) {
		if (pack == null) {
			return null;
		}

		int len = PackLength[pack[0]];
		if (len > 0) {
			pack[1] = (byte) 0x80;
			for (int i = 2; i < len; ++i) {
				pack[1] |= (pack[i] & 0x80) >> (9 - i);
				pack[i] |= 0x80;
			}
		}
		return pack;
	}

	private String mUserName;

	private int mYear = 0;
	private byte mMonth = 0;
	private byte mDay = 0;
	private byte mHour = 0;
	private byte mMin = 0;
	private byte mSec = 0;
	public int mPI = 1;// pi flag
	private int mDataLen = 0;
	public int mDATALEN = 0;

	private int dataCount = 0;

	public DeviceData mDeviceData = new DeviceData();
	// public ArrayList<DeviceData> mDeviceDatas = new ArrayList<DeviceData>();

	public DeviceDataIW mDeviceDataIW;
	public DeviceDataIW mSaveDeviceDataIW;
	public ArrayList<DeviceDataIW> mDeviceDataIWs = new ArrayList<DeviceDataIW>();

	public static boolean IS_SET_DATE_SUCCESS = false;
	private int mpiDataindex = 0;

	/**
	 * analyze the package from device
	 * 
	 * @param pack
	 * @return if have no other mean will return the Instruction byte ,else will
	 *         return other the other return has note ,read the method
	 *         <p>
	 *         0x05 ���յ��û���Ϣ<br>
	 *         <p>
	 *         0xAE ɾ�����ݳɹ�<br>
	 *         <p>
	 *         0xA2 ɾ������ʧ��<br>
	 *         <p>
	 *         0xB1 �����豸ʱ��ɹ�<br>
	 *         <p>
	 *         0xB2 �����豸���ڳɹ�<br>
	 *         <p>
	 *         0xB4 �����豸Ψһ��ʶ����һ�����˴���ʱδ�õ�����˻�δ������Ľ�����<br>
	 *         <p>
	 *         0xB5 �����豸Ψһ��ʶ���ڶ������˴���ʱδ�õ�����˻�δ������Ľ�����<br>
	 *         <p>
	 *         0xB7 ����ָ���������<br>
	 *         <p>
	 *         0x21 ��ʩ�豸ʱ��ʧ��<br>
	 *         <p>
	 *         0x22 �����豸����ʧ��<br>
	 *         <p>
	 *         0x16 �豸ʱ��<br>
	 *         <p>
	 *         0x17 �豸����<br>
	 *         <p>
	 *         0x18 У��������ȷ<br>
	 *         <p>
	 *         0x23 У���벻��ȷ<br>
	 *         <p>
	 *         0x0E �ɹ������� pi�ı�ʶ<br>
	 *         <p>
	 *         0x0A ���ݶ���<br>
	 *         <p>
	 *         0x01 ʵʱ����<br>
	 *         <p>
	 *         0x07 ���ݵĴ洢����<br>
	 *         <p>
	 *         0x12 ���ݵĴ洢ʱ��<br>
	 *         <p>
	 *         0x08 ���ݳ���<br>
	 *         <p>
	 *         0x0f ��PI������<br>
	 *         <p>
	 *         0x09 ��PI������<br>
	 * 
	 * 
	 */
	public byte processData(byte[] pack) {
		PrintBytes.printData(pack, pack.length);
		byte _return = (byte) 0x00;
		if (flag == false) {
			if (pack[0] != (byte) 0x20) {
				unPack(pack);
			}
		}
		PrintBytes.printData(pack, pack.length);
		switch (pack[0]) {
		case e_pack_username:
			int[] tmp = new int[6];
			for (int i = 0; i < 6; ++i) {
				tmp[i] = pack[i + 2];
				String str = new String(tmp, 0, 6);
				mUserName = str.trim();
			}
			return e_pack_username;
		case e_pack_feedback:
			byte _back = pack[2];
			byte _back_info = pack[3];
			switch (_back) {
			case (byte) 0xAE:
				if (_back_info == (byte) 0x00)
					return (byte) 0xAE;
				return (byte) 0xA2;
			case (byte) 0xB1:
				if (_back_info == (byte) 0x00)
					return (byte) 0xB1;// set time success
				return (byte) 0x21;// set time failed
			case (byte) 0xB2:
				if (_back_info == (byte) 0x00)
					return (byte) 0xB2;// set date success
				return (byte) 0x22;// set date failed
			case (byte) 0xB4:
				return (byte) 0xB4;
			case (byte) 0xB5:
				return (byte) 0xB5;
			case (byte) 0xB7:
				return (byte) 0xB7;
			}
			break;
		case e_pack_device_date:// device date
			return e_pack_device_date;
		case e_pack_check_sum:
			// if(mPI == 0){
			mSaveDeviceDataIW = mDeviceDataIW;
			mDeviceDataIWs.add(mDeviceDataIW);
			// }
			int low_eight = (CHECK_SUM & 0xff);
			int hight_eight = ((CHECK_SUM >> 8) & 0xff);

			CHECK_SUM = 0;
			int _low_eight = pack[3] & 0xff;
			int _hight_eight = pack[2] & 0xff;
			if ((low_eight == _low_eight) && (_hight_eight == hight_eight)) {
				return e_pack_check_sum;// check code is OK
			} else {
				return (byte) 0x23;// check code is wrong
			}
		case e_pack_pitype:
			mPI = pack[2];
			return e_pack_pitype;
		case e_pack_datacount:
			mDataCount = pack[3];
			return e_pack_datacount;
		case e_pack_realTimeData:
			return e_pack_realTimeData;
		case e_pack_savedate:

			// if(mPI == 1)
			sum_Check(pack);
			mYear = 2000 + pack[5];
			mMonth = pack[6];
			mDay = pack[7];
			// if(mPI == 0){
			if (mDeviceDataIW != null) {
				mSaveDeviceDataIW = mDeviceDataIW;
			}
			mDeviceDataIW = new DeviceDataIW();
			mDeviceDataIW._Year = mYear;
			mDeviceDataIW._Month = mMonth;
			mDeviceDataIW._Day = mDay;

			Log.e("日期", "----------->>: " + mYear + "-" + mMonth + "-" + mDay);
			// }
			return e_pack_savedate;
		case e_pack_savetime:
			// if(mPI == 1)
			sum_Check(pack);
			mHour = pack[4];
			mMin = pack[5];
			mSec = pack[6];
			// if(mPI ==0){
			mDeviceDataIW._Hour = mHour;
			mDeviceDataIW._Min = mMin;
			mDeviceDataIW._Sec = mSec;
			// }
			return e_pack_savetime;
		case e_pack_datalen:
			mDataLen = (0xff & pack[4]) | ((0xff & pack[5]) << 8)
					| ((0xff & pack[6]) << 16) | ((0xff & pack[7]) << 24);
			if (mPI == 0) {
				mDataLen = mDataLen / 4;
			} else {
				mDataLen = mDataLen / 2;
			}
			mDATALEN = mDataLen;
			mDeviceDataIW = new DeviceDataIW();
			mDeviceDataIW._DataLen = mDataLen;
			// mDeviceDataIW.value = new byte[mDataLen * 4];
			return e_pack_datalen;
		case e_pack_savedata:

			sum_Check(pack);
			byte[] value1 = new byte[4];
			value1[0] = pack[2];
			value1[1] = pack[3];
			mDeviceDataIW.valueList.add(value1);

			byte[] value2 = new byte[4];
			value2[0] = pack[4];
			value2[1] = pack[5];
			mDeviceDataIW.valueList.add(value2);

			byte[] value3 = new byte[4];
			value3[0] = pack[6];
			value3[1] = pack[7];
			mDeviceDataIW.valueList.add(value2);
			dataCount = dataCount + 3;
			// value[2] = pack[4];
			// value[3] = pack[5];
			Log.e("dataCount", "****: " + dataCount);
			// sum_Check(pack);
			// byte[] _value_ew = new byte[9];
			// _value_ew[0] = (byte) (mYear - 2000);
			// _value_ew[1] = mMonth;
			// _value_ew[2] = mDay;
			// _value_ew[3] = mHour;
			// _value_ew[4] = mMin;
			// _value_ew[5] = mSec;
			// _value_ew[6] = pack[2];
			// _value_ew[7] = pack[3];
			// _value_ew[8] = (byte)mPI;
			//
			// Log.e("*****", "****: " +"0x0f");
			// mDeviceData.valueList.add(_value_ew);
			// mDeviceData._SpO2 = pack[2];
			// mDeviceData._Pulse = pack[3];
			// mDeviceData._Pi = mPI;
			// mDeviceData._Year = mYear;
			// mDeviceData._Month = mMonth;
			// mDeviceData._Day = mDay;
			// mDeviceData._Hour = mHour;
			// mDeviceData._Sec = mSec;
			// mDeviceData._Min = mMin;

			// mDeviceDatas.add(mDeviceData);
			// Log.e("-------------", "len:"+mDeviceDatas.size());
			return e_pack_savedata;
		case e_pack_savedatapi:
			// sum_Check(pack);
			// byte[] value = new byte[4];
			// value[0] = pack[2];
			// value[1] = pack[3];
			// value[2] = pack[4];
			// value[3] = pack[5];
			// mDeviceDataIW.valueList.add(value);
			// Log.e("*****", "****: " +"9");
			// mpiDataindex++;
			return e_pack_savedatapi;
		case 0x06:
			mDeviceDataIW.Version = (pack[3] & 0xff) * 10 + (pack[2] & 0xff);
			return (byte) 0x89;

		case (byte) 0xCF:// 设备握手协议
			mSpo2h.mCodedata[0] = pack[1];
		    mSpo2h.mCodedata[1] = pack[2];
		    mSpo2h.mCodedata[2] = pack[3];
		    mSpo2h.mCodedata[3] = pack[4];
		    mSpo2h.mCodedata[4] = pack[5];
		    mSpo2h.mCodedata[5] = pack[6];
		    mSpo2h.mCodedata[6] = pack[7];
		    mSpo2h.mCodedata[7] = pack[8];
			return (byte) 0x35;// 成功

		case 0x20:
			PrintBytes.printData(pack);
			mDeviceDataIW.Code[0] = pack[1];
			mDeviceDataIW.Code[1] = pack[2];
			mDeviceDataIW.Code[2] = pack[3];
			mDeviceDataIW.Code[3] = pack[4];
			mDeviceDataIW.Code[4] = pack[5];
			mDeviceDataIW.Code[5] = pack[6];
			mDeviceDataIW.Code[6] = pack[7];
			mDeviceDataIW.Code[7] = pack[8];
			Log.e("=======校验码=====", "=======校验码=====");
			return (byte)0x20;

		case (byte) 0xF2:// 查询设备版本号
			return (byte) 0x45;

		case (byte) 0xF3:// 对时
			if (pack[1] == 0) {
				return (byte) 0x63;// 对时成功
			} else {
				return (byte) 0x64;// 对时失败
			}

		case (byte) 0xD0:// 查询连续数据的基本信息
			Log.e("==========", "当前数据的A0数据");
			// PrintBytes.printData(pack, pack.length);
			Log.e("==========", "A0打印完成");
			mSegmentLen = ((pack[12] & 0x7f) << 14) | ((pack[11] & 0x7f) << 7)
					| (pack[10] & 0x7f);
			Log.i("xiao", "连续数据值---" + mSegmentLen);
			if (mSegmentLen == 0) {// 无数据
				mPackCount = 0;
				switch (pack[1]) {
				case 0:// 脉率
					_return = (byte) 0x65;
					break;
				case 1:// 血氧
					_return = (byte) 0x66;
					break;
				}
			} else {// 有数据
				mPackCount = 0;
				switch (pack[1]) {
				case 0:// 脉率
					mSpo2h.PulseTime[0] = pack[2];
					mSpo2h.PulseTime[1] = pack[3];
					mSpo2h.PulseTime[2] = pack[4];
					mSpo2h.PulseTime[3] = pack[5];
					mSpo2h.PulseTime[4] = pack[6];
					mSpo2h.PulseTime[5] = pack[7];
					mSpo2h.PulseSegment = new byte[mSegmentLen];
					_return = (byte) 0x75;
					return _return;
				case 1:// 血氧
					mSpo2h.Spo2Time[0] = pack[2];
					mSpo2h.Spo2Time[1] = pack[3];
					mSpo2h.Spo2Time[2] = pack[4];
					mSpo2h.Spo2Time[3] = pack[5];
					mSpo2h.Spo2Time[4] = pack[6];
					mSpo2h.Spo2Time[5] = pack[7];
					mSpo2h.Spo2Segment = new byte[mSegmentLen];
					_return = (byte) 0x76;
					break;
				}
			}
			return _return;
		case (byte) 0xD1:// 删除连续数据
			if (pack[2] == 0) {// 删除成功
				switch (pack[1]) {
				case 0:// 删除脉率成功
					_return = (byte) 0xC0;
					break;
				case 1:// 删除血氧成功
					_return = (byte) 0xC1;
					break;
				}
			} else {// 删除失败
				switch (pack[1]) {
				case 0:// 删除脉率失败
					_return = (byte) 0xC2;
					break;
				case 1:// 删除血氧失败
					_return = (byte) 0xC3;
					break;
				}
			}
			return _return;
		case (byte) 0xD2:// 连续脉率数据
			// Log.e("==========", "当前数据的A2数据");
			// PrintBytes.printData(pack, pack.length);
			// Log.e("==========", "A2打印完成");
			pack = unNewPack(pack);
			if (mPackCount == mSegmentLen / 27) {
				int lastLen = mSegmentLen % 27;
				pluse = pack[5];
				mSpo2h.PulseSegment[mPackCount * 27] = pluse;
				for (int i = 1; i <= lastLen / 2; i++) {
					byte[] pluseData = unContinuousData(pluse, pack[5 + i]);
					mSpo2h.PulseSegment[mPackCount * 27 + i * 2 - 1] = pluseData[0];
					if ((mPackCount * 27 + i * 2) < mSegmentLen) {
						mSpo2h.PulseSegment[mPackCount * 27 + i * 2] = pluseData[1];
					}
					pluse = pluseData[1];
				}
				_return = (byte) 0x83;// 接收完毕
			} else {
				pluse = pack[5];
				mSpo2h.PulseSegment[mPackCount * 27] = pluse;
				for (int i = 1; i < 14; i++) {
					byte[] pluseData = unContinuousData(pluse, pack[5 + i]);
					mSpo2h.PulseSegment[mPackCount * 27 + i * 2 - 1] = (byte) (pluseData[0]);
					mSpo2h.PulseSegment[mPackCount * 27 + i * 2] = (byte) (pluseData[1]);
					pluse = pluseData[1];

				}
				_return = (byte) 0x82;// 接收中
				mPackCount++;
			}

			if (mPackCount == mSegmentLen / 27 && mSegmentLen % 27 == 0) {
				_return = (byte) 0x83;// 接收完毕
			}

			byte[] b = mSpo2h.PulseSegment;
			for (int i = 0; i < b.length; i++) {
				// Log.e("hxk", "连续脉率数据：-------->"+b[i]);
			}
			return _return;

		case (byte) 0xD3:// 连续血氧数据
			pack = unNewPack(pack);
			if (mPackCount == mSegmentLen / 27) {
				int lastLen = mSegmentLen % 27;
				spo2 = pack[5];
				if ((spo2 & 0xff) == 0xff) {
					spo2 = 0x7f;
				}
				mSpo2h.Spo2Segment[mPackCount * 27] = spo2;
				for (int i = 1; i <= lastLen / 2; i++) {
					byte[] spo2Data = unContinuousData(spo2, pack[5 + i]);
					if (((spo2Data[0]) & 0xff) == 0xff) {
						spo2Data[0] = 0x7F;
					}
					if (((spo2Data[1]) & 0xff) == 0xff) {
						spo2Data[1] = 0x7F;
					}
					mSpo2h.Spo2Segment[mPackCount * 27 + i * 2 - 1] = spo2Data[0];
					if ((mPackCount * 27 + i * 2) < mSegmentLen) {
						mSpo2h.Spo2Segment[mPackCount * 27 + i * 2] = spo2Data[1];
					}
					spo2 = spo2Data[1];
				}
				_return = (byte) 0x93;// 接收完毕
			} else {
				spo2 = pack[5];
				if ((spo2 & 0xff) == 0xff) {
					spo2 = 0x7f;
				}
				mSpo2h.Spo2Segment[mPackCount * 27] = spo2;
				for (int i = 1; i < 14; i++) {
					byte[] spo2Data = unContinuousData(spo2, pack[5 + i]);
					if (((spo2Data[0]) & 0xff) == 0xff) {
						spo2Data[0] = 0x7F;
					}
					if (((spo2Data[1]) & 0xff) == 0xff) {
						spo2Data[1] = 0x7F;
					}
					mSpo2h.Spo2Segment[mPackCount * 27 + i * 2 - 1] = spo2Data[0];
					mSpo2h.Spo2Segment[mPackCount * 27 + i * 2] = spo2Data[1];
					spo2 = spo2Data[1];
				}
				_return = (byte) 0x92;// 接收中
				mPackCount++;
			}

			if (mPackCount == mSegmentLen / 27 && mSegmentLen % 27 == 0) {
				_return = (byte) 0x93;// 接收完毕
			}
			byte[] b1 = mSpo2h.Spo2Segment;
			for (int i = 0; i < b1.length; i++) {
				// Log.i("hxk", "连续血氧数据：---->"+b1[i]);
			}
			return _return;
		}
		return (byte) 0x00;

	}

	/**
	 * 连续数据解析，将高位拼入
	 * 
	 * @param pack
	 * @return
	 */
	protected static byte[] unNewPack(byte[] pack) {
		for (int i = 0; i < 7; i++) {
			pack[5 + i] |= ((pack[3]) << (7 - i) & 0x80);
		}

		for (int j = 0; j < 7; j++) {
			pack[5 + 7 + j] |= ((pack[4]) << (7 - j) & 0x80);
		}

		return pack;
	}

	/**
	 * 通过差值解析连续数据
	 * 
	 * @param data
	 *            上一条数据作为标准值
	 * @param pack
	 *            需要计算的差值
	 * @return 返回解析好的两条数据
	 */
	protected static byte[] unContinuousData(byte data, byte pack) {
		byte high4 = (byte) ((pack & 0xF0) >> 4);
		byte low4 = (byte) (pack & 0x0F);
		byte high = (byte) (high4 & 0x07);
		byte low = (byte) (low4 & 0x07);
		byte highOne = (byte) ((pack & 0x80) >> 7);
		byte lowOne = (byte) ((pack & 0x08) >> 3);
		byte frist;
		byte second;
		if (high4 == 0x0F) {
			frist = (byte) 0xFF;
			second = (byte) 0xFF;
		} else {
			if (highOne == 0) {
				frist = (byte) (data + high);
			} else {
				frist = (byte) (data - high);
			}

			if (low4 == 0x0F) {
				second = (byte) 0xFF;
			} else {
				if (lowOne == 0) {
					second = (byte) (frist + low);
				} else {
					second = (byte) (frist - low);
				}
			}
		}

		byte[] unPackData = { frist, second };
		return unPackData;
	}
}
